#ifndef PRINT_H
#define PRINT_H

#include <QPrinter>
#include <QPainter>
#include <vector>
#include <QCoreApplication>
/*!
@file print.h
@brief Объявление класса Print - вывод на принтер и в файл.
*/

/*
Montgolfier - программа расчета воздушного шара.

Copyright (C) 2010 Igor Ulanov

	Это программа является свободным программным обеспечением. Вы можете распространять и/или модифицировать её согласно условиям Стандартной Общественной Лицензии GNU, опубликованной Фондом Свободного Программного Обеспечения, версии 3 или, по Вашему желанию, любой более поздней версии.
Эта программа распространяется в надежде, что она будет полезной, но БЕЗ ВСЯКИХ ГАРАНТИЙ, в том числе подразумеваемых гарантий ТОВАРНОГО СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ГОДНОСТИ ДЛЯ ОПРЕДЕЛЁННОГО ПРИМЕНЕНИЯ. Смотрите Стандартную Общественную Лицензию GNU для получения дополнительной информации.
Вы должны были получить копию Стандартной Общественной Лицензии GNU вместе с программой. В случае её отсутствия, посмотрите <http://www.gnu.org/licenses/gpl.html>.
*/

using namespace std;
/**
Класс обеспечивает вывод таблицы с данными выкройки для шара. Вывод осуществляется как на принтер так и в файл формата pdf. Имя файла создается по следующему шаблону - d100_a60_o12.pdf. Где число после буквы "d" - диаметр шара в см, число после "a" - угол раскрыва, после "o" - диаметр выходного отверстия.
*/
class Print
{
	Q_DECLARE_TR_FUNCTIONS(Print)
private:
	/// массив для хранения результатов вычисления выкройки.
	vector<float> data;
	/// координата y листа.
	int y; // высота строчки
	/** Функция, которая заполняет массив data вычисляемыми координатами выкройки. Функция заполнение выполняет тремя этапами, в каждом из этапов заполняя массив значениями для определенной части воздушного шара. Количество вычисляемых значений определяется шагом отсчетов выкройки, которое передается функции в параметрах. \param step - значение шага отсчетов выкройки (в см). */
	void Pattern(int);
	/** Функция выводящая координаты выкройки из массива data на лист QPrinter'а в виде таблицы. Первоначально расчитываются координаты таблиц, после чего рисуются вертикальные линии таблицы. Дальше выводится верхняя строка с названиями столбцов. Далее в цикле выводятся данные из масива и в последней части рисуются горизонтальные линии нижней части таблицы. \param g - ссылка на инструмент для  рисования.*/
	void Table(QPainter*);
	/** Функция печати заголовка. В заголовке печатаются основные параметры воздушного шара. Эти параметры перечислены в статическом массиве строк - Messages::name в строках с нулевой по девятую. \param g - ссылка на инструмент для  рисования.*/
	void Head(QPainter*);
	/** В этой функции печатается шар на весь лист. \param g - ссылка на инструмент для  рисования.*/
	void Ball(QPainter*); // функция рисования шара
public:
	Print();
	/** Главная функция класса. Резервируется память под массив, создается средство рисования QPainter, последовательно вызываются функции формирования страницы: Pattern, Ball, Head, Table, освобождается память зарезервированная под массив. \param p - ссылка на страницу для печати. \param d - значение шага отсчетов выкройки (в см).*/
	void Draw(QPrinter*,int);
	/** Функция записи csv или txt файла. Вызывается Pattern, который создает массив с данными выкройки, а дальше в цикле массив выводится в файл с разделителем пробели или точка с запятой.*/
	void Text(int,QString,QString);
};

#endif // PRINT_H
